
FUNCTION $1_BinSearch (searchFor$)
	SHARED $1_pool$[]
	SHARED $1_poolUM[]

	IFZ searchFor$ THEN RETURN
	IFZ $1_pool$[] THEN RETURN

	upper_slot = UBOUND ($1_pool$[])
	IF searchFor$ < $1_pool$[0] || searchFor$ > $1_pool$[upper_slot] THEN RETURN

	iSmall = 0
	iBig = upper_slot
	DO UNTIL iSmall > iBig
		slot = iSmall + ((iBig - iSmall) >> 1)
		IF $1_pool$[slot] = searchFor$ THEN RETURN (slot + 1)
		IF $1_pool$[slot] > searchFor$ THEN iBig = slot - 1 ELSE iSmall = slot + 1
	LOOP
END FUNCTION

FUNCTION $1_Reorg ()
	SHARED $1_pool$[]
	SHARED $1_poolUM[]

	upper_slot = UBOUND ($1_pool$[])
	index = -1
	FOR slot = 0 TO upper_slot
		IFF $1_poolUM[slot] THEN DO NEXT
		IFZ $1_pool$[slot] THEN DO NEXT
		INC index
		IF index < slot THEN
			$1_pool$[index] = $1_pool$[slot]
			$1_poolUM[index] = $$TRUE
			$1_pool$[slot] = ""
			$1_poolUM[slot] = $$FALSE
		ENDIF
	NEXT slot
	IF index = -1 THEN RETURN $$TRUE

	IF (index < upper_slot) THEN
		upper_slot = index
		REDIM $1_pool$[upper_slot]
		REDIM $1_poolUM[upper_slot]
	ENDIF
	bErr = $$TRUE
	SELECT CASE upper_slot
		CASE -1
		CASE 0 : IF $1_pool$[0] THEN bErr = $$FALSE
		CASE ELSE
			FOR a = upper_slot TO 0 STEP -1
				bDone = $$TRUE
				FOR b = 1 TO a
					IF $1_pool$[b - 1] > $1_pool$[b] THEN
						SWAP $1_pool$[b - 1], $1_pool$[b]
						bDone = $$FALSE
					ENDIF
				NEXT b
				IF bDone THEN EXIT FOR
			NEXT a
			bErr = $$FALSE
	END SELECT
	RETURN bErr
END FUNCTION