'
'
' [Quick]Sort $1 array in numerical order.
'
FUNCTION  XstQuickSort_$1 ($1 arr[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 partition
	$1 temp_item
	ULONG fOrder, midPoint, inf, sup, nPartition, i, j, temp_index
'
	IF (low >= high) THEN RETURN								' less than two elements
	inf = low
	sup = high
	midPoint = 0
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN
		IF ((sup - inf) = 1) THEN								' two element left
			IF (arr[inf] > arr[sup]) THEN RETURN			' arr[] correct order
			IF (arr[inf] < arr[sup]) THEN
				temp_item = arr[inf] : arr[inf] = arr[sup] :  arr[sup] = temp_item			' exchange arr[]'s items
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					temp_item = arr[inf] : arr[inf] = arr[sup] :  arr[sup] = temp_item			' exchange arr[]'s items
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		temp_item = arr[sup] : arr[sup] = arr[midPoint] :  arr[midPoint] = temp_item			' exchange arr[]'s items
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		partition = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE (i < j) && (arr[i] >= partition)
					INC i
				LOOP
				DO WHILE (j > i) && (arr[j] <= partition)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] < partition) THEN EXIT DO
					IF (arr[i] = partition) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] > partition) THEN EXIT DO
					IF (arr[j] = partition) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				temp_item = arr[i] : arr[i] = arr[j] :  arr[j] = temp_item			' exchange arr[]'s items
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((sup - inf) = 1) THEN								' two element left
			IF (arr[inf] < arr[sup]) THEN RETURN			' arr[] correct order
			IF (arr[inf] > arr[sup]) THEN
				temp_item = arr[inf] : arr[inf] = arr[sup] :  arr[sup] = temp_item			' exchange arr[]'s items
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					temp_item = arr[inf] : arr[inf] = arr[sup] :  arr[sup] = temp_item			' exchange arr[]'s items
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		temp_item = arr[sup] : arr[sup] = arr[midPoint] :  arr[midPoint] = temp_item			' exchange arr[]'s items
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		partition = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE (i < j) && (arr[i] <= partition)
					INC i
				LOOP
				DO WHILE (j > i) && (arr[j] >= partition)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] > partition) THEN EXIT DO
					IF (arr[i] = partition) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] < partition) THEN EXIT DO
					IF (arr[j] = partition) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				temp_item = arr[i] : arr[i] = arr[j] :  arr[j] = temp_item			' exchange arr[]'s items
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	temp_item = arr[i] : arr[i] = arr[sup] :  arr[sup] = temp_item			' exchange arr[]'s items
	IF n[] THEN temp_index = n[i] : n[i] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
'
	IF (i > (inf + 1)) THEN XstQuickSort_$1 (@arr[], @n[], inf, (i-1), fOrder)
	IF (i < (sup - 1)) THEN XstQuickSort_$1 (@arr[], @n[], (i+1), sup, fOrder)
'
END FUNCTION