'
'
' [Quick]Sort $1 array in alphabetical order.
'
FUNCTION  XstQuickSort_$1 ($1 arr[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 part_$1
	ULONG fOrder, midPoint, inf, sup, nPartition, i, j, temp_index
'
	IF (low >= high) THEN RETURN								' less than two elements
	inf = low
	sup = high
	midPoint = 0
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN
		IF ((sup - inf) = 1) THEN								' two element left
			IF (arr[inf] > arr[sup]) THEN RETURN			' arr[] correct order
			IF (arr[inf] < arr[sup]) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		part_$1 = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE (i < j) && (arr[i] >= part_$1)
					INC i
				LOOP
				DO WHILE (j > i) && (arr[j] <= part_$1)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] < part_$1) THEN EXIT DO
					IF (arr[i] = part_$1) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] > part_$1) THEN EXIT DO
					IF (arr[j] = part_$1) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((sup - inf) = 1) THEN								' two element left
			IF (arr[inf] < arr[sup]) THEN RETURN			' arr[] correct order
			IF (arr[inf] > arr[sup]) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		part_$1 = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE (i < j) && (arr[i] <= part_$1)
					INC i
				LOOP
				DO WHILE (j > i) && (arr[j] >= part_$1)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (arr[i] > part_$1) THEN EXIT DO
					IF (arr[i] = part_$1) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (arr[j] < part_$1) THEN EXIT DO
					IF (arr[j] = part_$1) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr[i], arr[sup]
	IF n[] THEN temp_index = n[i] : n[i] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
'
	IF (i > (inf + 1)) THEN XstQuickSort_$1 (@arr[], @n[], inf, (i-1), fOrder)
	IF (i < (sup - 1)) THEN XstQuickSort_$1 (@arr[], @n[], (i+1), sup, fOrder)
'
END FUNCTION
'
'
'  [Quick]Sort $1 array in alphabetical order, case insensitive.
'
FUNCTION  XstQuickSort_$1_nocase ($1 arr[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 part_$1
	ULONG fOrder, midPoint, inf, sup, nPartition, i, j, temp_index
'
	IF (low >= high) THEN RETURN								' less than two elements
	inf = low
	sup = high
	midPoint = 0
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN				' "Z" to "A"
		IF ((sup - inf) = 1) THEN								' two element left
			IF (UCASE$(arr[inf]) > UCASE$(arr[sup])) THEN RETURN			' arr[] correct order
			IF (UCASE$(arr[inf]) < UCASE$(arr[sup])) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		IF n[] THEN nPartition = n[sup]
		part_$1 = UCASE$(arr[sup])
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE ((i < j) && (UCASE$(arr[i]) >= part_$1))
					INC i
				LOOP
				DO WHILE ((j > i) && (UCASE$(arr[j]) <= part_$1))
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (UCASE$(arr[i]) < part_$1) THEN EXIT DO
					IF (UCASE$(arr[i]) = part_$1) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (UCASE$(arr[j]) > part_$1) THEN EXIT DO
					IF (UCASE$(arr[j]) = part_$1) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((sup - inf) = 1) THEN								' two element left
			IF (UCASE$(arr[inf]) < UCASE$(arr[sup])) THEN RETURN			' arr[] correct order
			IF (UCASE$(arr[inf]) > UCASE$(arr[sup])) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		IF n[] THEN nPartition = n[sup]
		part_$1 = UCASE$(arr[sup])
		i = inf: j = sup
		DO
			IFZ n[] THEN
				DO WHILE (i < j) && (UCASE$(arr[i]) <= part_$1)
					INC i
				LOOP
				DO WHILE (j > i) && (UCASE$(arr[j]) >= part_$1)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					IF (UCASE$(arr[i]) > part_$1) THEN EXIT DO
					IF (UCASE$(arr[i]) = part_$1) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					IF (UCASE$(arr[j]) < part_$1) THEN EXIT DO
					IF (UCASE$(arr[j]) = part_$1) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr[i], arr[sup]
	IF n[] THEN temp_index = n[i] : n[i] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
'
	IF (i > (inf + 1)) THEN XstQuickSort_$1_nocase (@arr[], @n[], inf, (i-1), fOrder)
	IF (i < (sup - 1)) THEN XstQuickSort_$1_nocase (@arr[], @n[], (i+1), sup, fOrder)
'
END FUNCTION
'
'
'  [Quick]Sort $1 array in numerical order.
'
FUNCTION  XstQuickSort_Numeric$1 ($1 arr[], XLONG n[], XLONG low, XLONG high, XLONG flags)

	$1 part_$1
	ULONG fOrder, midPoint, inf, sup, nPartition, i, j, temp_index
'
	IF (low >= high) THEN RETURN								' less than two elements
	inf = low
	sup = high
	midPoint = 0
'
	IF (flags AND $$SortDecreasing) THEN
		fOrder = $$SortDecreasing
	ELSE
		fOrder = $$SortIncreasing
	ENDIF
'
	IF (fOrder = $$SortDecreasing) THEN				' "z" to "A"
		IF ((sup - inf) = 1) THEN								' two element left
			'IF (arr[inf] > arr[sup]) THEN RETURN			' arr[] correct order
			IF XstCompareStrings (&arr[inf], $$GT, &arr[sup], fOrder) THEN RETURN			' arr[] correct order
			'IF (arr[inf] < arr[sup]) THEN
			IF XstCompareStrings (&arr[inf], $$LT, &arr[sup], fOrder) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		part_$1 = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				'DO WHILE ((i < j) && (arr[i] >= part_$1))
				DO WHILE ((i < j) && XstCompareStrings (&arr[i], $$GE, &part_$1, fOrder))
					INC i
				LOOP
				'DO WHILE ((j > i) && (arr[j] <= part_$1))
				DO WHILE ((j > i) && XstCompareStrings (&arr[j], $$LE, &part_$1, fOrder))
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					'IF (arr[i] < part_$1) THEN EXIT DO
					IF XstCompareStrings (&arr[i], $$LT, &part_$1, fOrder) THEN EXIT DO
					'IF (arr[i] = part_$1) THEN
					IF XstCompareStrings (&arr[i], $$EQ, &part_$1, fOrder) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					'IF (arr[j] > part_$1) THEN EXIT DO
					IF XstCompareStrings (&arr[j], $$GT, &part_$1, fOrder) THEN EXIT DO
					'IF (arr[j] = part_$1) THEN
					IF XstCompareStrings (&arr[j], $$EQ, &part_$1, fOrder) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ELSE
		IF ((sup - inf) = 1) THEN								' two element left
			'IF (arr[inf] < arr[sup]) THEN RETURN			' arr[] correct order
			IF XstCompareStrings (&arr[inf], $$LT, &arr[sup], fOrder) THEN RETURN			' arr[] correct order
			'IF (arr[inf] > arr[sup]) THEN
			IF XstCompareStrings (&arr[inf], $$GT, &arr[sup], fOrder) THEN
				SWAP arr[inf], arr[sup]
				IF n[] THEN temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
			ELSE
				IFZ n[] THEN RETURN										' arr[] equal:  use n[]
				IF (n[inf] > n[sup]) THEN						' n[] sort $$SortIncreasing
					SWAP arr[inf], arr[sup]
					temp_index = n[inf] : n[inf] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
				ENDIF
			ENDIF
			RETURN
		ENDIF

		midPoint = (sup + inf) >> 1

		SWAP arr[sup], arr[midPoint]
		IF n[] THEN temp_index = n[sup] : n[sup] = n[midPoint] :  n[midPoint] = temp_index			' exchange n[]'s items
		'
		part_$1 = arr[sup]
		IF n[] THEN nPartition = n[sup]
		i = inf: j = sup
		DO
			IFZ n[] THEN
				'DO WHILE (i < j) && (arr[i] <= part_$1)
				DO WHILE (i < j) && XstCompareStrings (&arr[i], $$LE, &part_$1, fOrder)
					INC i
				LOOP
				'DO WHILE (j > i) && (arr[j] >= part_$1)
				DO WHILE (j > i) && XstCompareStrings (&arr[j], $$GE, &part_$1, fOrder)
					DEC j
				LOOP
			ELSE
				DO WHILE (i < j)
					'IF (arr[i] > part_$1) THEN EXIT DO
					IF XstCompareStrings (&arr[i], $$GT, &part_$1, fOrder) THEN EXIT DO
					'IF (arr[i] = part_$1) THEN
					IF XstCompareStrings (&arr[i], $$EQ, &part_$1, fOrder) THEN
						IF (n[i] > nPartition) THEN EXIT DO
					ENDIF
					INC i
				LOOP
				DO WHILE (j > i)
					'IF (arr[j] < part_$1) THEN EXIT DO
					IF XstCompareStrings (&arr[j], $$LT, &part_$1, fOrder) THEN EXIT DO
					'IF (arr[j] = part_$1) THEN
					IF XstCompareStrings (&arr[j], $$EQ, &part_$1, fOrder) THEN
						IF (n[j] < nPartition) THEN EXIT DO
					ENDIF
					DEC j
				LOOP
			ENDIF
			IF (i < j) THEN
				SWAP arr[i], arr[j]
				IF n[] THEN temp_index = n[i] : n[i] = n[j] :  n[j] = temp_index			' exchange n[]'s items
			ENDIF
		LOOP WHILE (i < j)
	ENDIF
'
	SWAP arr[i], arr[sup]
	IF n[] THEN temp_index = n[i] : n[i] = n[sup] :  n[sup] = temp_index			' exchange n[]'s items
'
	IF (i > (inf + 1)) THEN XstQuickSort_Numeric$1 (@arr[], @n[], inf, (i-1), fOrder)
	IF (i < (sup - 1)) THEN XstQuickSort_Numeric$1 (@arr[], @n[], (i+1), sup, fOrder)
'
END FUNCTION