
FUNCTION $1_Active ($1_id)
	SHARED $1_poolUM[]

	slot = $1_id - 1
	IF (slot >= 0) && (slot <= UBOUND ($1_poolUM[])) THEN
		IF $1_poolUM[slot] THEN RETURN $$TRUE
	ENDIF
END FUNCTION

FUNCTION $1_Find (searchFor$)
	SHARED $1_pool$[]
	SHARED $1_poolUM[]

	$1_id = 0
	crit$ = TRIM$ (searchFor$)
	LEN_crit = LEN (crit$)

	SELECT CASE LEN_crit
		CASE 0
		CASE ELSE
			IFZ $1_poolUM[] THEN EXIT SELECT
			FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
				IFF $1_poolUM[slot] THEN DO NEXT
				try$ = TRIM$ ($1_pool$[slot])
				IF (LEN (try$) = LEN_crit) THEN
					IF try$ = crit$ THEN
						$1_id = slot + 1 : EXIT FOR
					ENDIF
				ENDIF
			NEXT slot
	END SELECT
	RETURN $1_id
END FUNCTION

FUNCTION $1_FindIns (searchFor$)
	SHARED $1_pool$[]
	SHARED $1_poolUM[]

	$1_id = 0
	crit$ = UCASE$ (TRIM$ (searchFor$))
	LEN_crit = LEN (crit$)

	SELECT CASE LEN_crit
		CASE 0
		CASE ELSE
			IFZ $1_poolUM[] THEN EXIT SELECT
			FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
				IFF $1_poolUM[slot] THEN DO NEXT
				try$ = TRIM$ ($1_pool$[slot])
				IF (LEN (try$) = LEN_crit) THEN
					try$ = UCASE$ (try$)
					IF try$ = crit$ THEN
						$1_id = slot + 1 : EXIT FOR
					ENDIF
				ENDIF
			NEXT slot
	END SELECT
	RETURN $1_id
END FUNCTION

FUNCTION $1_Get_count ()
	SHARED $1_poolUM[]

	count = 0
	IF $1_poolUM[] THEN
		FOR slot = UBOUND ($1_poolUM[]) TO 0 STEP -1
			IF $1_poolUM[slot] THEN INC count
		NEXT slot
	ENDIF
	RETURN count
END FUNCTION

FUNCTION $1_Get_idMin ()
	SHARED $1_poolUM[]

	idMin = 0
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = 0 TO upper_slot
			IF $1_poolUM[slot] THEN
				idMin = slot + 1
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	RETURN idMin
END FUNCTION

FUNCTION $1_GetNext (@$1_id, @$1_item$)
	SHARED $1_pool$[]
	SHARED $1_poolUM[]

	bOK = $$FALSE
	IF $1_poolUM[] THEN
		upper_slot = UBOUND ($1_poolUM[])
		FOR slot = $1_id TO upper_slot
			IF $1_poolUM[slot] THEN
				bOK = $$TRUE
				$1_id = slot + 1
				$1_item$ = $1_pool$[slot]
				EXIT FOR
			ENDIF
		NEXT slot
	ENDIF
	IFF bOK THEN
		$1_item$ = ""
	ENDIF
	RETURN bOK
END FUNCTION